<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FeatureSubType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FeatureSubType extends AbstractStructArrayBase
{
    /**
     * The FeatureSubType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FeatureSubType[]
     */
    public $FeatureSubType;
    /**
     * Constructor method for ArrayOfJP_FeatureSubType
     * @uses ArrayOfJP_FeatureSubType::setFeatureSubType()
     * @param \StructType\JP_FeatureSubType[] $featureSubType
     */
    public function __construct(array $featureSubType = array())
    {
        $this
            ->setFeatureSubType($featureSubType);
    }
    /**
     * Get FeatureSubType value
     * @return \StructType\JP_FeatureSubType[]|null
     */
    public function getFeatureSubType()
    {
        return $this->FeatureSubType;
    }
    /**
     * This method is responsible for validating the values passed to the setFeatureSubType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFeatureSubType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFeatureSubTypeForArrayConstraintsFromSetFeatureSubType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FeatureSubTypeFeatureSubTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FeatureSubTypeFeatureSubTypeItem instanceof \StructType\JP_FeatureSubType) {
                $invalidValues[] = is_object($arrayOfJP_FeatureSubTypeFeatureSubTypeItem) ? get_class($arrayOfJP_FeatureSubTypeFeatureSubTypeItem) : sprintf('%s(%s)', gettype($arrayOfJP_FeatureSubTypeFeatureSubTypeItem), var_export($arrayOfJP_FeatureSubTypeFeatureSubTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FeatureSubType property can only contain items of type \StructType\JP_FeatureSubType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FeatureSubType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FeatureSubType[] $featureSubType
     * @return \ArrayType\ArrayOfJP_FeatureSubType
     */
    public function setFeatureSubType(array $featureSubType = array())
    {
        // validation for constraint: array
        if ('' !== ($featureSubTypeArrayErrorMessage = self::validateFeatureSubTypeForArrayConstraintsFromSetFeatureSubType($featureSubType))) {
            throw new \InvalidArgumentException($featureSubTypeArrayErrorMessage, __LINE__);
        }
        $this->FeatureSubType = $featureSubType;
        return $this;
    }
    /**
     * Add item to FeatureSubType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FeatureSubType $item
     * @return \ArrayType\ArrayOfJP_FeatureSubType
     */
    public function addToFeatureSubType(\StructType\JP_FeatureSubType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FeatureSubType) {
            throw new \InvalidArgumentException(sprintf('The FeatureSubType property can only contain items of type \StructType\JP_FeatureSubType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FeatureSubType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FeatureSubType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FeatureSubType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FeatureSubType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FeatureSubType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FeatureSubType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FeatureSubType
     */
    public function getAttributeName()
    {
        return 'FeatureSubType';
    }
}
